:- load_library('alice.tucson.api.Tucson2PLibrary').

draw(node,X,Y,Name) :-
	gv <- node(X,Y,Name).

start :-
	java_object('simulazione.GraphViewer',[],gv),
	java_object('simulazione.LogViewer',[scooter],lvs),
	java_object('simulazione.LogViewer',[genius],lvg),
	class('alice.util.Tools') <- loadText('simulazione/scooter.pl') returns Th1,
	java_object('alice.tuprolog.Agent',[Th1,'start(scooter).'],scooter),
	scooter <- spawn,
	write("scooter spawn"),
	class('alice.util.Tools') <- loadText('simulazione/run.pl') returns Th2,
	java_object('alice.tuprolog.Agent',[Th2,'start(genius).'],genius),
	genius <- spawn,
	write("genius spawn"),
	enter_context([agent_id(gv)]),
	cmd ? in(controller(start)),
	cmd ? in(param(agentGV,Grafo)),
	draw_graph(Grafo),
	cmd ? out(start_sim),
	cmd ? in(endSim(scooter)),
	cmd ? in(endSim(genius)),
	lg  ? in(count(TimeEnd)),
	TimeStart = 0,
	Dt is TimeEnd div 10,
	class('simulazione.Controller') <- getController returns ctr,
	ctr <- disableBtn(3),
	cmd ? in(controller(next)),
	DtEnd is Dt + TimeStart,
	usa(Dt,DtEnd,TimeStart,TimeEnd),
	ctr <- disableBtn(2),
	exit_context.
	
trace(log(scooter,A,B,Now)) :-
	nodo(A,X1,Y1),
	nodo(B,X2,Y2),
	draw(line,X1,Y1,X2,Y2,red),
	lvs <- print(trans(A,B,time(Now))).
trace(log(genius,A,B,Now)) :-
	nodo(A,X1,Y1),
	nodo(B,X2,Y2),
	draw(line,X1,Y1,X2,Y2,blue),
	lvg <- print(trans(A,B,time(Now))).
trace(log(demo,A,B,Now)) :-
	nodo(B,X2,Y2),
	draw(line,X2,Y2,X2,Y2,blue),
	lvg <- print(demo(A,B,time(Now))).
trace(log(genius,A,failed,Now)) :-
	lvg <- print(genius("FAILED",time(Now))).

draw_graph(X) :-
	X =.. [graph|List],
	addTrans(List).


usa(Dt,DtEnd,End,End).
usa(Dt,Now,Now,End) :-
	DtEnd1 is Dt + Now,
	cmd ? in(controller(next)),
	usa(Dt,DtEnd1,Now,End).
usa(Dt,DtEnd,Now,End) :-
	lg ? in(log(ID,A,B,Now)),
	trace(log(ID,A,B,Now)),
	Now1 is Now + 1,
	usa(Dt,DtEnd,Now1,End).
addTrans([_,_]).
addTrans([H|T]) :-
	H =.. [node,[ID,X,Y],_],
	draw(node,X,Y,ID),
	assertz(nodo(ID,X,Y)),
	addTrans(T).
addTrans([H|T]) :-
	H =.. [link,[ID1,ID2],_],
	nodo(ID1,X1,Y1),
	nodo(ID2,X2,Y2),
	draw(arrow,X1,Y1,X2,Y2),
	assertz(arco(ID1,ID2)),
	addTrans(T).
draw(line,Xi,Yi,Xf,Yf,C) :-
	gv <- line(Xi,Yi,Xf,Yf,C).
draw(arrow,Xi,Yi,Xf,Yf) :-
	gv <- arrow(Xi,Yi,Xf,Yf).
