:- load_library('alice.tucson.api.Tucson2PLibrary').
:- load_library('simulazione.ACLTLibrary').

run(I,F,[F|P],P,N,N) :-
	arc(I,F),
	write(runEnd),
	nl.
run(I,F,P,Path,N,Nt) :-
	write(run),
	arc(I,I2),
	not member(I2,Path),
	N1 is Nt + 1,
	run(I2,F,P,[I2|Path],N,N1).

solve(I,F,P) :-
	run(I,F,P,[I],N,1).
	
start(IDGenius) :-
	enter_context([agent_id(IDGenius)]),
	cmd ? in(startSim(IDGenius)),
	cmd ? in(param(IDGenius,I,F,Mode)),
	assertz(mode(Mode)),
	((solve(I,F,P),
	reverse(P,P1),!,
	write(P1),nl,
	exec(P1,IDGenius));
	lg ? out(log(genius,I,failed))),
	cmd ? out(endSim(IDGenius)),
	write("genius terminato"),nl,
	exit_context.
	
exec([_],_).
exec([H|T],IDGenius) :-
	T = [H1|T1],
	write(trans(IDGenius,H,H1)),
	lg ? out(log(IDGenius,H,H1)),
	exec(T,IDGenius).

arc(I,F) :-
	mode(demo),
	demo(arco(I,F),tc),
	lg ? out(log(demo,I,F)).
arc(I,F) :-
	mode(demoLast),
	demoLast(arco(I,F),tc),
	lg ? out(log(demo,I,F)).
arc(I,F) :-
	mode(demoWait),
	demoWait(arco(I,F),tc),
	lg ? out(log(demo,I,F)).
arc(I,F) :-
	mode(demoWaitLast),
	demoWaitLast(arco(I,F),tc),
	lg ? out(log(demo,I,F)).
