package myLibrary;

import alice.tuprolog.*;

/**
* Libreria per tuProlog. Consente di leggere un documento xml
* trasformandolo in un albero astratto. Questo viene concretizzato
* in Prolog sottoforma di predicato che ha per nome l'elemento
* radice dell'albero e per argomenti i figli e una lista con
* gli attributi della radice.
*
* @author Alex Benini
*/
public class SAXParserLibrary extends Library {


	// builtin predicate parseElem("file",Tree)
	public boolean parseElem_2(Struct g){
		Term tree;
		try {
		  Term file = g.getTerm(0);
          if (!file.isAtom()) {
              return false;
          }
          //uri  il file xml da processare
          String uri = ((Struct)file).getName();
          SAXParser parser = new SAXParser();
          //conversione del file xml in un albero
          tree = parser.parseElem(uri);
		} catch(Exception e) {
			System.out.println("Errore SAXParserLibrary");
			e.printStackTrace();
			return false;
		}
		//Si verifica se  unificabile ad una variabile d'uscita
		// o ad un'altro albero (2argomento)
		return unify(tree, g.getTerm(1));
	}//parseElem


	// builtin predicate parseElemAttr("file",Tree)
	public boolean parseElemAttr_2(Struct g){
		Term tree;
		try {
		  Term file = g.getTerm(0);
          if (!file.isAtom()) {
              return false;
          }
          String uri = ((Struct)file).getName();
          SAXParser parser = new SAXParser();
          tree = parser.parseElemAttr(uri);
		} catch(Exception e) {
			System.out.println("Errore SAXParserLibrary");
			e.printStackTrace();
			return false;
		}
		return unify(tree, g.getTerm(1));
	}//parseElem


	// builtin predicate parseElem("file",Tree)
/*	public boolean parseAll_2(Struct g){
		Term tree;
		try {
		  Term file = g.getTerm(0);
          if (!file.isAtom()) {
              return false;
          }
          String uri = ((Struct)file).getName();
          SAXParser parser = new SAXParser();
          tree = parser.parseElem(uri);
		} catch(Exception e) {return false;}
		return unify(tree, g.getTerm(1));
	}//parseElem
*/

}
