//
//  Controller.java
//  Controller
//
//
package simulazione;

import java.awt.*;
import java.awt.event.*;
import java.awt.event.KeyEvent;
import javax.swing.*;

import alice.tucson.api.*;
import alice.logictuple.*;

public class Controller extends JFrame {

	private Font font = new Font("serif", Font.ITALIC+Font.BOLD, 36);
	private Container c;
	private JButton demoBtn, demoLBtn, demoWBtn, demoLWBtn, nextBtn, quitBtn;
	private static Controller controller;
	public JTextField fileField, iterazioniField, inizioGField, inizioSField, fineField;
	public  TucsonContext cn;
	
	public Controller() {
		super("Controller center");
		c = this.getContentPane();
		demoBtn  = new JButton("Demo Simulation");
		demoLBtn = new JButton("DemoLast Sim.");
		demoWBtn = new JButton("DemoWait Sim.");
		demoLWBtn= new JButton("DemoWaitLast Sim.");
		nextBtn  = new JButton("Log by Step");
		quitBtn  = new JButton("Quit");
		fileField = new JTextField("grafo.xml");
		iterazioniField = new JTextField("40");
		inizioGField = new JTextField("a1");
		inizioSField = new JTextField("a1");
		fineField = new JTextField("f6");
		try {
		  //installo il nodo dell'infrastruttura Tucson
		  try{
			  new alice.tuprolog.Agent("","java_object('alice.tucson.runtime.Node',[],node), node <- install.").spawn();
			  while (!alice.tucson.runtime.Node.isInstalled()) {
				Thread.sleep(1000);//attende il caricamento totale di Node
			  }
              Thread.sleep(10000);//attende il caricamento totale di Node
		  }catch(Exception e1){e1.printStackTrace();}

		  cn = Tucson.enterDefaultContext();
		  TupleCentreId tid = new TupleCentreId("cmd");
	      demoBtn.addActionListener(new BtnHandler(this,0,tid));
	      demoLBtn.addActionListener(new BtnHandler(this,1,tid));
	      demoWBtn.addActionListener(new BtnHandler(this,2,tid));
	      demoLWBtn.addActionListener(new BtnHandler(this,3,tid));
		  nextBtn.addActionListener(new BtnHandler(this,4,tid));
		  quitBtn.addActionListener(new BtnHandler(this,5,tid));
		  cn.setSpec(tid,
		     "reaction(out(start_sim),(in_r(start_sim),out_r(startSim(genius)),out_r(startSim(scooter)))). \n"
		  );
		  TupleCentreId tid2 = new TupleCentreId("lg");
		  cn.setSpec(tid2,
		     "reaction(out(log(ID,A,B)),(in_r(log(ID,A,B)),in_r(count(N)),out_r(log(ID,A,B,N)), N1 is N + 1, out_r(count(N1)) )). \n"
		  );
		  cn.out(tid2,new LogicTuple("count",new Value(0)));
		  TupleCentreId tid3 = new TupleCentreId("tc");
		  cn.setSpec(tid3,
"reaction(inp(rd_all(T,L)),(\n"+
	"pre,\n"+
	"out_r(rdall_collect(T,[])))).\n"+
"reaction(out_r(rdall_collect(T,L)),(\n"+
	"current_tuple(rdall_collect(T1,_)),\n"+
	"in_r(T1),\n"+
	"in_r(rdall_collect(T,L)),\n"+
	"out_r(rdall_collect(T,[T1|L])))).\n"+
"reaction(out_r(rdall_collect(T,_)),(\n"+
	"current_tuple(rdall_collect(T1,_)),\n"+
	"no_r(T1),\n"+
	"in_r(rdall_collect(T,L)),\n"+
	"out_r(rd_all(T,L)),\n"+
	"out_r(rdall_restore(L)) )).\n"+
"reaction(out_r(rdall_restore([])),(\n"+
	"in_r(rdall_restore([])) )).\n"+
"reaction(out_r(rdall_restore([H|T])),(\n"+
	"in_r(rdall_restore([H|T])),\n"+
	"out_r(H),\n"+
	"out_r(rdall_restore(T)) )).\n"+
"reaction(out(arco(X,Y)),(\n"+
	"in_r(arco(X,Y)),\n"+
	"rd_r(arco(X,Y)))).\n"+
//Reaction notEmpty	
"reaction(inp(empty),(no_r(X),out_r(empty))).\n"
		  );
		} catch(Exception ex){System.out.println("Error: TupleCentreID");}
		c.setLayout(new GridLayout(3,5));
		c.add(demoBtn);
		c.add(demoLBtn);
		c.add(demoWBtn);
		c.add(demoLWBtn);
		c.add(nextBtn);
		c.add(quitBtn);
		disableBtn(1); //Log = 1
		c.add(new JLabel("Grafo nomefile "));
		c.add(new JLabel("Nodo inizio Genius "));
		c.add(new JLabel("Nodo fine Genius "));
		c.add(new JLabel("Nodo inizio Scooter "));
		c.add(new JLabel("N iterazioni Scooter "));
		c.add(new JLabel(""));
		c.add(fileField);
		c.add(inizioGField);
		c.add(fineField);
		c.add(inizioSField);
		c.add(iterazioniField);
		setSize(1000,100);
		setVisible(true);

		//Creo l'AgentGV
		try{
			new alice.tuprolog.Agent(alice.util.Tools.loadText("simulazione/agentGV.pl"),"start.").spawn();
		}catch(Exception e){e.printStackTrace();}
	}

	public void paint(Graphics g) {
		super.paint(g);
	}

    //Cmd = 3, Tutti = 2, Log = 1
	public void disableBtn(int x) {
		demoBtn.setEnabled((x==1)?true:false);
		demoLBtn.setEnabled((x==1)?true:false);
		demoWBtn.setEnabled((x==1)?true:false);
		demoLWBtn.setEnabled((x==1)?true:false);
		nextBtn.setEnabled((x==3)?true:false);
	}
	
	public void quit() {
		System.exit(0);
	}

	public static void main(String args[]){
		controller = new Controller();
	}

	public static Controller getController(){
		return controller;
	}
	
}


class BtnHandler implements ActionListener {
	
	Controller app;
	int    cmd;
	TupleCentreId tid;
	myLibrary.SAXParser parserXML = new myLibrary.SAXParser();
	
	BtnHandler(Controller app, int cmd, TupleCentreId tid){
		this.app = app;
		this.cmd = cmd;
		this.tid = tid;
	}
	
	public void actionPerformed(ActionEvent e){
		try{
		  Value mode = new Value("demo");
		  if (cmd==1) mode = new Value("demoLast");
		  if (cmd==2) mode = new Value("demoWait");
		  if (cmd==3) mode = new Value("demoWaitLast");
		  if (cmd>-1 && cmd<4) {
			app.cn.out(tid,new LogicTuple("param",
				new Value("genius"),
				new Value(app.inizioGField.getText()),
				new Value(app.fineField.getText()),
				mode
			));
			app.cn.out(tid,new LogicTuple("param",
				new Value("scooter"),
				new Value(app.inizioSField.getText()),
				new Value(Integer.parseInt(app.iterazioniField.getText())),
				new TupleArgument(parserXML.parseElemAttr(app.fileField.getText()))
			));
			app.cn.out(tid,new LogicTuple("param",
				new Value("agentGV"),
				new TupleArgument(parserXML.parseElemAttr(app.fileField.getText()))
			));
			app.cn.out(tid,new LogicTuple("controller",new Value("start")));
			app.disableBtn(2); //Cmd = 3, Tutti = 2, Log = 1
		  }
		  if (cmd==4) app.cn.out(tid,new LogicTuple("controller",new Value("next")));
		  if (cmd==5) app.quit();
		}catch(Exception ex){
			System.out.println("Error: out in cmd tuple centre");
			ex.printStackTrace();
		}
		app.repaint();
	}
}