//
//  GraphViewer.java
//  GraphViewer
//
package simulazione;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

public class GraphViewer extends JFrame {

	int w=600;
	int h=500;
	Vector stk = new Vector();
	
	public GraphViewer() {
		
		super("GraphViewer");
		setSize(w,h);
		setVisible(true);
		repaint();
		
	}
	

	public void paintComponent(Graphics g){
		update(g);
	}


	public void update(Graphics g) {
		Graphics2D g2 = (Graphics2D)g;
		//create and set the stroke
		g2.setStroke(new BasicStroke(0.6f));
		for(int i=0;i<stk.size();i++){
			Object[] v = (Object[])(stk.get(i));
			g2.setColor((Color)(v[1]));
			g2.draw((Shape)(v[0]));
			g2.setFont((Font)(v[2]));
			g2.drawString((String)v[3],((Float)v[4]).floatValue(),((Float)v[5]).floatValue());
		}
	}


	public void node(String xs, String ys, String name){
		int x = Integer.parseInt(xs);
		int y = Integer.parseInt(ys);
		System.out.println("x="+x+"y="+y);
		//grid distanza 40
		//create an ellipse and use it as the clipping path
		Object[] s = new Object[6];
		s[0]=new Ellipse2D.Float((float)(x*40),(float)(y*40),30.0f,30.0f);
		s[1]=Color.BLACK;
		s[2]=new Font("arial", 0, 12);
		s[3]=name;
		s[4]=new Float(x*40);
		s[5]=new Float(y*40);
		stk.add(s);
		//Fill the canvas. Only the area within the clip is rendered
		repaint();
	}

	public void arrow(String x1s, String y1s, String x2s, String y2s){
		int x1 = Integer.parseInt(x1s);
		int y1 = Integer.parseInt(y1s);
		int x2 = Integer.parseInt(x2s);
		int y2 = Integer.parseInt(y2s);
		//grid distanza 40
		x1=x1*40;
		y1=y1*40;
		x2=x2*40;
		y2=y2*40;
		int x = Math.abs(x1-x2);
		int vx= (x1-x2)>0 ? -1 : +1;
		int y = Math.abs(y1-y2);
		int vy= (y1-y2)>0 ? -1 : +1;
		double ipo = Math.sqrt(x*x+y*y);
		Line2D e1 = new Line2D.Double((x1+15+(15*x/ipo)*vx),(y1+15+(15*y/ipo)*vy),(x2+15-(15*x/ipo)*vx),(y2+15-(15*y/ipo)*vy));
		Object[] s1 = new Object[6];
		s1[0]=e1;
		s1[1]=Color.BLACK;
		s1[2]=new Font("arial", 0, 12);
		s1[3]="";
		s1[4]=new Float(0);
		s1[5]=new Float(0);		
		stk.add(s1);
		Ellipse2D e2 = new Ellipse2D.Double((x2+15-(15*x/ipo)*vx)-3,(y2+15-(15*y/ipo)*vy)-3,6d,6d);
		Object[] s2 = new Object[6];
		s2[0]=e2;
		s2[1]=Color.BLACK;
		s2[2]=new Font("arial", 0, 12);
		s2[3]="";
		s2[4]=new Float(0);
		s2[5]=new Float(0);		
		stk.add(s2);
		
		//Fill the canvas. Only the area within the clip is rendered
		repaint();
	}


	public void line(String x1s, String y1s, String x2s, String y2s, String color){
		int x1 = Integer.parseInt(x1s);
		int y1 = Integer.parseInt(y1s);
		int x2 = Integer.parseInt(x2s);
		int y2 = Integer.parseInt(y2s);
		//grid distanza 40
		x1=x1*40;
		y1=y1*40;
		x2=x2*40;
		y2=y2*40;
		int d = (color.equals("red")) ? 1 : -2;
		Line2D e = new Line2D.Double(x1+15+d,y1+15+d,x2+15+d,y2+15+d);
		Object[] s = new Object[6];
		s[0]=e;
		s[1]= (color.equals("red")) ? Color.RED : Color.BLUE;
		s[2]=new Font("arial", 0, 12);
		s[3]="";
		s[4]=new Float(0);
		s[5]=new Float(0);
		stk.add(s);
		
		//Fill the canvas. Only the area within the clip is rendered
		repaint();
	}

 
}