:- load_library('alice.tucson.api.Tucson2PLibrary').

walk(IDScooter,A,S) :-
	S =< 0.
walk(IDScooter,A,Stop) :-
	bagof(arco(A,X),arco(A,X),L),
	%write(L),
	size(L,N),
	N > 0,
	random(M),
	I is M mod N,
	select(L,I,arco(A,T)),
	%write(' '),
	%write(T),
	%nl,
	lg ? out(log(IDScooter,A,T)),
	tc ? out(arco(A,T)),
	S is Stop - 1,!,
	walk(IDScooter,T,S).
start(IDScooter) :-
	java_object('java.util.Random',[],rand),
	enter_context([agent_id(IDScooter)]),
	cmd ? in(startSim(IDScooter)),
	cmd ? in(param(IDScooter,Inizio,Stop,Grafo)),
	load_graph(Grafo),
	walk(IDScooter,Inizio,Stop),
	cmd ? out(endSim(IDScooter)),
	write("scooter terminato"),nl,
	exit_context.
load_graph(X) :-
	X =.. [graph|List],
	addTrans(List).

size([],0) :-
	true.
size([_|T],N) :-
	size(T,N1),
	N is N1 + 1.

select([H|_],0,H) :-
	true.
select([H|T],I,X) :-
	I2 is I - 1,
	select(T,I2,X).

addTrans([_,_]) :-
	true.
addTrans([H|T]) :-
	H =.. [node,[_,_,_],_],
	addTrans(T).
addTrans([H|T]) :-
	H =.. [link,[ID1,ID2],_],
	assertz(arco(ID1,ID2)),
	addTrans(T).
random(X) :-
	rand <- nextInt(100) returns X.
